﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace WindowsFormsApplication12
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
    }

    public class MyTree: RadTreeView
    {
        public override string ThemeClassName
        {
            get
            {
                return typeof(RadTreeView).FullName;
            }
        }

        protected override RadTreeViewElement  CreateTreeViewElement()
        {
 	         return new MyTreeViewElement();
        }
    }

    public class MyTreeViewElement : RadTreeViewElement
    {
        private RadDropDownMenu menu;
        RadTreeNode rightClickedNode;

        public RadDropDownMenu customMenu
        {
            get 
            {
                return this.menu;
            }
        }

        public RadTreeNode RightClickedNode
        {
            get
            {
                return this.rightClickedNode;
            }
        }

        public MyTreeViewElement()
        {
            menu = new RadDropDownMenu();
            menu.DropDownOpening += new CancelEventHandler(menu_DropDownOpening);
        }

        void InitializeContextMenu()
        {
            menu.Items.Clear();
            menu.Items.Add(new RadMenuItem("Delete"));
            menu.Items.Add(new RadMenuItem("Insert"));
            menu.Items.Add(new RadMenuItem("Add"));
        }

        void menu_DropDownOpening(object sender, CancelEventArgs e)
        {
            InitializeContextMenu();

            //here you can modify the custom context menu
            if (rightClickedNode.Text == "Node6")
            {
                menu.Items[2].Enabled = false;
            }
        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(RadTreeViewElement);
            }
        }

        protected override bool ProcessMouseDown(MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                TreeNodeElement nodeElement = GetNodeElementAt(e.Location);
                if (nodeElement != null && !nodeElement.Data.Current)
                {
                    return false;
                }
            }
            return base.ProcessMouseDown(e);
        }

        protected override bool ProcessContextMenu(Point location)
        {
            if (IsEditing)
            {
                this.EndEdit();
            }

            // here we can take the right-clicked node
            rightClickedNode = this.GetNodeAt(location);
            if (rightClickedNode != null)
            {
                menu.Show(this.ElementTree.Control, location);
                return true;
            }
            
            return base.ProcessContextMenu(location);
        }
    }
}
